<?
//Developed by: Moe Sweet <moesweet@myanmar.com.mm>
//From: Myanmar (Burma)
//Date: 28-June-07

class TrueColorPicker{

	//Determine how many nubmer of steps/blocks between each corner of the picker
	//least detail: 16, fast
	//true color, Photoshop-standard: 256, slow
	//optimal: 64	
	var $detailFactor;//
	
	//a color code to be appeared in "Current" pane
	var $preloadColor;

	//Constructor
	function TrueColorPicker(){
		$this->detailFactor=64;//default detail factor

	}	
	//set default factor
	#function setDf($df){
	#	if($df>=16 && $df<=256){
	#		$this->detailFactor = $df;
	#	}
	#}

	
	function setPreload($preload){
		$this->preloadColor = $preload;
	}
	function build(){
		$borderColor = "#666666";
	?>
	<table cellpadding="5" cellspacing="0" style="border:2px <?=$borderColor?> solid;background:#dddddd;font-family:Verdana, Arial, Helvetica, sans-serif;font-size:10px;width:420px">
		<tr>
			<!-- Brightness box -->
			<td rowspan="3"  width="256" height="256" align="left" valign="top">
					<div id="brightnessBoxContainer">
					Click the bar on the right
					</div>
				</td>
			<!-- Spacing-->
			<td rowspan="3" width="3"></td>
			<!-- Hue Box -->
			<td rowspan="3"><?=$this->buildHueBox()?></td>
			<td align="center" valign="top" width="100" height="100" style="position:relative">
            	<div id="mouseLeft">Mouse</div>
                <div id="mouseRight">Mouse</div>
                <div id="newLeft">New</div>
                <div id="newRight">New</div>
                <div id="currentLeft">Current</div>
                <div id="currentRight">Current</div>
				<img style="border-left:1px <?=$borderColor?> solid;
                			border-top:1px <?=$borderColor?> solid;
                            border-right:1px <?=$borderColor?> solid"
                           	id="imgMouse" src="drawColorElement.php?colorCode=ffffff&width=100&height=25">
				<img style="border-left:1px <?=$borderColor?> solid;
                            border-right:1px <?=$borderColor?> solid" id="imgNew" src="drawColorElement.php?colorCode=ffffff&width=100&height=50">
				<?
				
				if(empty($this->preloadColor)){
					$preloadColor = '00ffff';
				} else{
					$preloadColor = $this->preloadColor;
				}				
				?>
				<img style="border-left:1px <?=$borderColor?> solid;
                			border-bottom:1px <?=$borderColor?> solid;
                            border-right:1px <?=$borderColor?> solid" id="imgCurrent" src="drawColorElement.php?colorCode=<?=$preloadColor?>&width=100&height=50" onclick="brightnessBoxClick('<?=$preloadColor?>')">

			</td>
		</tr>
		<tr>
			<td width="100" height="60" valign="bottom" align="right" style="font-family:'Courier New', Courier, monospace;font-size:14px;padding-right:2px">
					 # <input id="txtSelectedColorCode" style="font-family:'Courier New', Courier, monospace" type="text" size="6" value="ffffff"/>
			</td>
		</tr>
		<tr>
			<td align="right" valign="bottom" style="padding:0 2px 2px 0">
				<button type="button" onclick="okClick()">OK</button><button type="button" onclick="cancelClick()">Cancel</button>
			</td>
		</tr>
	</table>
	<?
	}
	//Private
	function buildHueBox(){
		$hueFile = "hueColors.txt";
		eval(file_get_contents($hueFile));		
		?><table cellpadding="0" cellspacing="0" style="background:url('hueBox.png')" width="20" height="258"><?
			foreach($hueArray as $hueColorCode){
				?><tr><td onclick="hueColorClick('<?=substr($hueColorCode,1,6)?>',<?=$this->detailFactor?>);setArrowsPosition();" height="1">
				  </td></tr><?	
			}
		?></table><?
	}

}
?>