// JavaScript Document
var htmlId;
var currentX;
var currentY;
var currentArrowsPos = 0;
var currentBc = '';
var lastClickedColor = '';
var tempX;
var tempY;
var IE = document.all?true:false;
if (!IE) document.captureEvents(Event.MOUSEMOVE);

//****************************
// Customize these 2 functions
//****************************
function okClick(){
	clr = (document.getElementById("txtSelectedColorCode").value);
	window.opener.passColorCode(htmlId, clr, currentArrowsPos, currentBc, currentX, currentY);
	self.close();
}

function cancelClick(){
	window.close();
}

function init(htmlIdPassed,preload,bc,arrowsPosition,cLeft,cTop){
	
	htmlId = htmlIdPassed;
	/* To Preposition crosshair */
	currentX = cLeft;
	currentY = cTop;
	currentArrowsPos = arrowsPosition;
	currentBc = bc;
	lastClickedColor = preload;
	
	var posleft;
	posleft = 275;  //IE 
	posleft = 273;  //Firefox
	Drag.init(document.getElementById("arrowsColorPicker"),null, posleft, posleft, 8, 265);
	Drag.init(document.getElementById("arrowsColorPicker"),null, posleft, posleft, 8, 265);
	document.onmousemove = getMouseXY; // I Put this to make the first click on the huebox move the arrow
	document.getElementById("arrowsColorPicker").style.top = arrowsPosition +"px";
	
	/* To display a brightnessbox before any clicking */
	hueColorClick(bc,64);
	document.getElementById("imgNew").src = 'drawColorElement.php?colorCode=' + preload + '&width=100&height=50';
}
function hueColorClick(baseColor,detailFactor){

	currentBc = baseColor;
	readTextWithGet('buildBrightnessTable.php?df=' + detailFactor + '&bc=' + baseColor + '&currentX=' + currentX + '&currentY=' + currentY,showColorPanelInDiv,'');
}

function showColorPanelInDiv(returnScript){
	eval(returnScript);
	//Reload the whole box
	document.getElementById("brightnessBoxContainer").innerHTML = brightnessTable;
	// Reload Selected Color
	document.getElementById("imgNew").src = 'drawColorElement.php?colorCode=' + reloadColorCode + '&width=100&height=50';
	lastClickedColor = reloadColorCode;
	// Reload Textbox
	document.getElementById("txtSelectedColorCode").value = reloadColorCode;
}

//function brightnessBoxClick(){
	//alert(crosshairX + ',' + crosshairY);

//	document.getElementById("imgNew").src = 'drawColorElement.php?colorCode=' + clr + '&width=100&height=50';
//	document.getElementById("txtSelectedColorCode").value = clr;
//}
function brightnessBoxOut(){
		
}
function brightnessBoxHover(clr){
	document.getElementById("imgMouse").src = 'drawColorElement.php?colorCode=' + clr + '&width=100&height=25';
}
function brightnessBoxClick(clr,crosshairX,crosshairY){
	currentX = crosshairX;
	currentY = crosshairY;
	moveCrosshair(crosshairX,crosshairY);	
	document.getElementById("imgNew").src = 'drawColorElement.php?colorCode=' + clr + '&width=100&height=50';
	document.getElementById("txtSelectedColorCode").value = clr;
}

function moveCrosshair(x,y){
	document.getElementById('crosshair').style.left = x + 'px';
	document.getElementById('crosshair').style.top = y + 'px';
}

function setArrowsPosition(){
	document.onmousemove = getMouseXY;
	currentArrowsPos = tempY -5 ;
	document.getElementById("arrowsColorPicker").style.top = currentArrowsPos +"px";
}

function getMouseXY(e) {
	if (IE) { // grab the x-y pos.s if browser is IE
	tempX = event.clientX + document.body.scrollLeft;
	tempY = event.clientY + document.body.scrollTop;
	}
	else {  // grab the x-y pos.s if browser is NS
	tempX = e.pageX;
	tempY = e.pageY;
	}  
	if (tempX < 0){tempX = 0;}
	if (tempY < 0){tempY = 0;}  

	return true;
}

var xmlHttpRequestObjGroup 	= new Array();	// this is to store Http Request Objects 
var arrayTracker			= new Array();	// this is to store "OK" or "Not OK" to overwrite HttpRequestObject
var objIndex				= null;			// index to the xmlHttpRequestObjGroup and arrayTracker
/**
This function creates http request object depending on the browser with which user view.
**/
function createObject()
{
	var xmlHttpRequestObject = false;

	if (window.XMLHttpRequest){ // if Mozilla, Safari etc
		if(checkArrayTrack()){
			xmlHttpRequestObjGroup[objIndex] = new XMLHttpRequest();
			arrayTracker[objIndex] = "Not OK to overwrite";
			xmlHttpRequestObject = xmlHttpRequestObjGroup[objIndex];
		}else{
			xmlHttpRequestObjGroup.push(new XMLHttpRequest());
			arrayTracker.push("Not OK to overwrite");
			objIndex = xmlHttpRequestObjGroup.length-1;
			xmlHttpRequestObject = xmlHttpRequestObjGroup[objIndex];
		}
	}
	else if (window.ActiveXObject){ // if IE
		try {
			if(checkArrayTrack()){
				xmlHttpRequestObjGroup[objIndex] = new ActiveXObject("Msxml2.XMLHTTP");
				arrayTracker[objIndex] = "Not OK to overwrite";
				xmlHttpRequestObject = xmlHttpRequestObjGroup[objIndex];
			}else{			
				xmlHttpRequestObjGroup.push(new ActiveXObject("Msxml2.XMLHTTP"));
				arrayTracker.push("Not OK to overwrite");
				objIndex = xmlHttpRequestObjGroup.length-1;
				xmlHttpRequestObject = xmlHttpRequestObjGroup[objIndex];			
			}
		} 
		catch (e){
			try{
				if(checkArrayTrack()){
					xmlHttpRequestObjGroup[objIndex] = new ActiveXObject("Microsoft.XMLHTTP");
					arrayTracker[objIndex] = "Not OK to overwrite";
					xmlHttpRequestObject = xmlHttpRequestObjGroup[objIndex];
				}else{						
					xmlHttpRequestObjGroup.push(new ActiveXObject("Microsoft.XMLHTTP"));
					arrayTracker.push("Not OK to overwrite");
					objIndex = xmlHttpRequestObjGroup.length-1;
					xmlHttpRequestObject = xmlHttpRequestObjGroup[objIndex];				
				}
			}
			catch (e){}
		}
	}
	else{
		alert('This browswer cannot support HttpRequest Object!');
		return false;
	}
	
	return xmlHttpRequestObject;
}
/**
 *This function destroys http request object
*/
function destroyObject(object){
	delete object;
	object = null;
	arrayTracker[objIndex] = 'OK to overwrite';
}
/**
 * This function checks one of the arrayTracker is available ('ok to overwrite')
**/
function checkArrayTrack(){
	for(i=0; i<arrayTracker.length; i++){
		if(arrayTracker[i] == 'OK to overwrite'){
			objIndex = i;
			return true;
		}
	}
	return false;
}
/*
 * This function is directly set the data downloaded from server into the innerHTML property of the container. 
 * And preload information is supported.
*/
function requestPage(url, containerid, preload)
{
	if(preload != undefined){
		document.getElementById(containerid).innerHTML = preload;
	}
	
	var xmlHttpRequestObject = createObject();
	if(xmlHttpRequestObject)
	{	
		xmlHttpRequestObject.open('GET', url, true);
		xmlHttpRequestObject.onreadystatechange=function()
		{
			if (xmlHttpRequestObject.readyState == 4 && xmlHttpRequestObject.status==200)
			{
				//alert(xmlHttpRequestObject.responseText);
				document.getElementById(containerid).innerHTML = xmlHttpRequestObject.responseText;
				destroyObject(xmlHttpRequestObject);
			}
		}
		
	}	
	xmlHttpRequestObject.send(null)	
}

/*
 * This function download the text from the server and return it to the call back function 
*/
function readTextWithGet(urlToCall, functionToCallBack, /*optional object*/preload){
	//if third parameter was passed and only if it is a object
	
	if(preload != undefined && typeof preload == "object")
	{
		document.getElementById(preload.container).innerHTML = preload.text || "Please wait...";
	}
	
	var xmlHttpRequestObject = createObject();
	if(xmlHttpRequestObject){
		xmlHttpRequestObject.open("GET", urlToCall);
		xmlHttpRequestObject.onreadystatechange = function()
		{	
			if(xmlHttpRequestObject.readyState == 4 && xmlHttpRequestObject.status == 200){
				
				functionToCallBack(xmlHttpRequestObject.responseText);
				destroyObject(xmlHttpRequestObject);
			}
		}
	}
	xmlHttpRequestObject.send(null);
}
